/*======================================头像自动分割（抠头像）接口---人体脸部抠图接口_不含头发======================================*/
package main

import (
	"bytes"
	"crypto/md5"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io/ioutil"
	"log"
	"net/http"
)

func ImgtoBase64PersonFace(filePath string) string {
	//图片转Base64
	bytes, err := ioutil.ReadFile(filePath)
	if err != nil {
		log.Fatal(err)
	}
	var base64Encoding string
	base64Encoding += base64.StdEncoding.EncodeToString(bytes)
	return base64Encoding
}

func MD5PersonFace(v string) string {
	d := []byte(v)
	m := md5.New()
	m.Write(d)
	b := m.Sum(nil)
	return base64.StdEncoding.EncodeToString([]byte(b))
}

func main() {
	appCode := "你的appcode"
	SegmentMattingUrl := "https://person.market.alicloudapi.com/segment/person/face"

	client := &http.Client{}
	data := make(map[string]interface{})
	data["photo"] = ImgtoBase64PersonFace("1.jpg")
	data["type"] = "jpg"

	bytesData, _ := json.Marshal(data)
	req, _ := http.NewRequest("POST", SegmentMattingUrl, bytes.NewReader(bytesData))
	req.Header.Set("Content-Type", "application/json")
	req.Header.Set("Authorization", "APPCODE "+appCode)

	md5Str := MD5PersonFace(string(bytesData))
	req.Header.Set("Content-MD5", md5Str)

	resp, _ := client.Do(req)
	fmt.Println(resp.Header)
	fmt.Println(resp.Header["X-Ca-Error-Message"])
	body, _ := ioutil.ReadAll(resp.Body)
	fmt.Println(string(body))

}
